import Prefops

Class Prefops/Binary -superclass Prefops

Prefops/Binary public compare_cost { c1 c2 } {
	if { $c1 > $c2 } {
		return 1
	} elseif { $c1 < $c2 } {
		return -1
	} else {
		return 0
	}
}

# Pref operations

#
# Return a "Zero" pv
#
Prefops/Binary public zero { } {
	return [list "*" 0]
}

#
# Return a max pv
#
Prefops/Binary public max { } {
	return [list "*" 1]
}

#
# Return an empty pv
#
Prefops/Binary public empty { } {
	return [list "*" -]
}

#
# Add two preference vectors pv1 pv2. 
# Return a pv.
# Boolean logic OR.
#
Prefops/Binary public add { pv1 pv2 } {
	if { [lindex $pv1 1] || [lindex $pv2 1] } {
		return [list "*" 1]
	} else {
		return [list "*" 0]
	}
}

#
# Add a scalar to a preference vector
# Return a scalar.
#
Prefops/Binary public add_s { s pv } {
	return [expr $s + [lindex $pv 1]]
}		

#
# Subtract preference vector pv2 from pv1.
# Return a pv.
# Boolean logic XOR.
#
Prefops/Binary public subtract { pv1 pv2 } {
	if { [lindex $pv1 1] ^ [lindex $pv2 1] } {
		return [list "*" 1]
	} else {
		return [list "*" 0]		
	}
}

#
# Multiply a preference vector pv by a scalar.
# Return a pv.
#
Prefops/Binary public scale { pv s } {
	return $pv
}

#
# Absolute value of preference vector.
#
Prefops/Binary public abs { pv } {
	return $pv
}
