#
# Operations and database on receiver preferences.
# Abstract class. Application should define all methods.
#
Class Prefops


#
# Find the cost of the current partition.
#
Prefops public get_cost { } {
}

#
# Return whether cost c is acceptable when compared to threshold.
#
Prefops public acceptable { cost thresh } {
}

#
# Receiver or source (host) has died.
# Aged out the associated records to avoid considering them in alg.
#
Prefops public delete { ctype id } {
}

#
# Heartbeat message from source.
#
Prefops public set_df { src_id lpv } {
}

#
# Insert preference vector list lpv of receiver recv_id into database.
# Also add to clustering alg.
#
Prefops public set_pv { recv_id lpv } {
}

#
# Find preference vector of receiver recv_id on source src_id
#
Prefops public get_pv { recv_id src_id } {
}

#
# Return all the sources 
#
Prefops public get_srclist { } {
}

#
# Return all the receivers
#
Prefops public get_recvlist { } {
}

#
# Add two preference vectors pv1 pv2.
# Return a pv.
#
Prefops public add { pv1 pv2 } {
}

#
# Subtract preference vector pv2 from pv1.
# Return a pv.
#
Prefops public subtract { pv1 pv2 } {
}

#
# Multiply a preference vector pv by a scalar.
# Return a pv.
#
Prefops public scale { pv s } {
}

#
# Absolute value of preference vector.
#
Prefops public abs { pv } {
}