#
# Copyright (c) 1998 Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#       This product includes software developed by the Computer Systems
#       Engineering Group at Lawrence Berkeley Laboratory.
# 4. Neither the name of the University nor of the Laboratory may be used
#    to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# ------------
#
# Filename: install.tcl
#   -- Created on Tue Apr 14 1998
#   -- Author: Yatin Chawathe <yatin@cs.berkeley.edu>
#
# Description:
#
#
#  @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/mplug/install.tcl,v 1.1 1998/04/29 00:15:30 yatin Exp $
#


Class MPlugInstaller

MPlugInstaller public init { mimetype script_name script } {
	$self next

	# create a button
	button .b -text "Install" -command [list $self do $mimetype \
			$script_name $script]
	pack .b -expand 1 -fill both
}


MPlugInstaller private do { mimetype script_name script } {
	$self install $mimetype $script_name $script
	.b config -text "Done" -state disabled
}


MPlugInstaller private install { mimetype script_name script } {
	# write the script to disk in ~/.mash/scripts/$script_name
	set mash [glob ~]/.mash
	if ![file exists $mash] {
		file mkdir $mash
	}
	if ![file exists $mash/scripts] {
		file mkdir $mash/scripts
	}

	set f [open $mash/scripts/$script_name w 0644]
	puts $f $script
	close $f
	
	set f [open $mash/prefs-mplug a+ 0644]
	puts $f "script.$mimetype: $mash/scripts/$script_name"
	close $f
}

